;Message format:
;0-126:		character
;127: 		end message
;128:		first third selector, followed by a byte indicating the number of character
;129:		second third selector, followed by a byte indicating the number of character
;130:		third third selector, followed by a byte indicating the number of character
;131:		simple color, followed by a byte indicating the number of character repetitions, and another byte indicating the color itself
;132-255:	color code. substract 132, the resulting byte will have 3 bits (6-4) describing the colorset to use
;			and the lower 4 bits (3-0), telling the number of characters to apply the colorset-1

;FIXED MESSAGES: since we are in ROM, the non fixed messages appear in "variables.asm" file
message_presskey:	defb	128,170,131,5,225,CHR_P,CHR_R,CHR_E,CHR_S,CHR_S,128,177,131,5,225,CHR_A,CHR_SPACE,CHR_K,CHR_E,CHR_Y,127
mes_mark_1st:		defb	CHR_W,CHR_I,CHR_N,CHR_N,CHR_E,CHR_R
mes_mark_2nd:		defb	CHR_S,CHR_E,CHR_C,CHR_O,CHR_N,CHR_D
mes_mark_3rd:		defb	CHR_T,CHR_H,CHR_I,CHR_R,CHR_D,CHR_SPACE
mes_mark_4th:		defb	CHR_L,CHR_O,CHR_S,CHR_E,CHR_R,CHR_EXCL
mes_mt_toomuch:		defb	CHR_MINUS,CHR_MINUS,CHR_MINUS,CHR_MINUS,CHR_MINUS,CHR_MINUS

tr_presskey:		defb	130,10,131,19,225,CHR_A,CHR_N,CHR_Y,CHR_SPACE,CHR_K,CHR_E,CHR_Y,CHR_SPACE,CHR_T,CHR_O,CHR_SPACE,CHR_C,CHR_O,CHR_N
			defb	CHR_T,CHR_I,CHR_N,CHR_U,CHR_E
			defb	127
tr_trackres_fixed:	defb	128,1,131,15,225,CHR_T,CHR_R,CHR_A,CHR_C,CHR_K,CHR_E,CHR_S,CHR_U,CHR_L,CHR_O,CHR_I,CHR_M,CHR_B,CHR_P,CHR_N	
			defb	130,1,131,9,225,CHR_C,CHR_L,CHR_A,CHR_S,CHR_I,CHR_F,CHR_T,CHR_O,CHR_N
			defb	129,131,131,59,18
			defb	127
message_replay:		defb	130,10,131,28,225,CHR_E,CHR_P,CHR_L,CHR_A,CHR_Y,CHR_SPACE,CHR_MINUS,CHR_SPACE,CHR_O,CHR_T,CHR_H,CHR_E,CHR_R,CHR_SPACE,CHR_T
			defb	CHR_O,CHR_SPACE,CHR_C,CHR_O,CHR_N,CHR_T,CHR_I,CHR_N,CHR_U,CHR_E,CHR_R,CHR_T,CHR_O
			defb	127

mmenu_fixed:		defb	128,57,131,14,225
			defb	128,57,CHR_E,CHR_X,CHR_T,CHR_R,CHR_A,CHR_K,CHR_Y,CHR_S,CHR_COLON,CHR_P,CHR_U,CHR_O,CHR_N,CHR_D
			defb	128,73,131+16*1+13,CHR_1
			defb	128,86,131+16*2+13,CHR_2
			defb	128,99,131+16*3+13,CHR_3
			defb	128,112,131+16*4+13,CHR_4
			defb	129,1,131,12,225,CHR_5,CHR_C,CHR_A,CHR_M,CHR_1,CHR_2,CHR_R,CHR_E,CHR_D,CHR_F,CHR_I,CHR_N
			defb	129,13,131,10,129,CHR_6,CHR_C,CHR_A,CHR_T,CHR_E,CHR_G,CHR_O,CHR_R,CHR_Y,CHR_COLON
			defb	129,23,131,16,49,CHR_7,CHR_8,CHR_C,CHR_H,CHR_A,CHR_M,CHR_P,CHR_I,CHR_O,CHR_N,CHR_S,CHR_COLON,CHR_E,CHR_R,CHR_L,CHR_Z
			defb	129,39,131,6,129,129,45,131,8,49,129,53,131,14,225
			defb	130,1,131,32,225
			defb	127
mmenu_0start:		defb	130,33,131,8,225,CHR_0,CHR_S,CHR_T,CHR_A,CHR_R,CHR_G,CHR_M,CHR_E
mmenu_noredefine:	defb	129,53,CHR_SPACE,CHR_SPACE,CHR_SPACE,CHR_SPACE,CHR_SPACE,CHR_SPACE,CHR_SPACE,CHR_SPACE
			defb	CHR_SPACE,CHR_SPACE,CHR_SPACE,CHR_SPACE,127

mmenu_keyfor:		defb	129,53,CHR_K,CHR_E,CHR_Y,CHR_F,CHR_O,CHR_R,127

mmenu_cat0:		defb	CHR_F,CHR_1,CHR_SPACE,CHR_SPACE,CHR_SPACE,CHR_SPACE,127
			defb	CHR_G,CHR_P,CHR_2,CHR_SPACE,CHR_SPACE,CHR_SPACE,127
			defb	CHR_K,CHR_A,CHR_R,CHR_T,CHR_S,CHR_SPACE,127
			defb	CHR_J,CHR_U,CHR_N,CHR_I,CHR_O,CHR_R,127
			
mmenu_champ0:		defb	CHR_E,CHR_A,CHR_S,CHR_Y,CHR_SPACE,CHR_SPACE,CHR_SPACE,CHR_SPACE,127
			defb	CHR_H,CHR_A,CHR_R,CHR_D,CHR_SPACE,CHR_SPACE,CHR_SPACE,CHR_SPACE,127
			defb	CHR_C,CHR_O,CHR_M,CHR_P,CHR_L,CHR_E,CHR_T,CHR_E,127
			defb	CHR_P,CHR_E,CHR_R,CHR_S,CHR_O,CHR_N,CHR_A,CHR_L,127


message_credits:	defb	128,57,131,18,225,CHR_A,CHR_B,CHR_C,CHR_D,CHR_E,CHR_G,CHR_H,CHR_I,CHR_K,CHR_M,CHR_O,CHR_P,CHR_R,CHR_S,CHR_T,CHR_Y,CHR_COLON,CHR_AMPER
			defb	131,9,241,CHR_M,CHR_E,CHR_T,CHR_A,CHR_L,CHR_B,CHR_R,CHR_I,CHR_N
			defb	129,1,131,10,225,CHR_C,CHR_E,CHR_I,CHR_M,CHR_O,CHR_R,CHR_S,CHR_U,CHR_V,CHR_COLON
			defb	131,16,241,CHR_A,CHR_C,CHR_D,CHR_E,CHR_I,CHR_J,CHR_K,CHR_L,CHR_N,CHR_O,CHR_R,CHR_S,CHR_U,CHR_W,CHR_Y,CHR_Z
			defb	130,33,131,24,225,CHR_3,CHR_A,CHR_B,CHR_C,CHR_D,CHR_E,CHR_G,CHR_H,CHR_I,CHR_K,CHR_L,CHR_M,CHR_N,CHR_O,CHR_P
			defb	CHR_R,CHR_S,CHR_T,CHR_U,CHR_X,CHR_Y,CHR_Z,CHR_COLON,CHR_MINUS
			defb	131,15,113,CHR_A,CHR_D,CHR_E,CHR_G,CHR_H,CHR_I,CHR_L,CHR_M,CHR_N,CHR_P,CHR_R,CHR_S,CHR_T,CHR_U,CHR_Z
			defb	131,6,177,CHR_A,CHR_C,CHR_E,CHR_M,CHR_T,CHR_Z
			defb	127

mmenu_rede_right:	defb	CHR_R,CHR_I,CHR_G,CHR_H,CHR_T,CHR_INTERR,127
mmenu_rede_left:	defb	CHR_L,CHR_E,CHR_F,CHR_T,CHR_INTERR,CHR_SPACE,127
mmenu_rede_up:		defb	CHR_U,CHR_P,CHR_INTERR,CHR_SPACE,CHR_SPACE,CHR_SPACE,127
mmenu_rede_down:	defb	CHR_D,CHR_O,CHR_W,CHR_N,CHR_INTERR,CHR_SPACE,127
mmenu_rede_pause:	defb	CHR_P,CHR_A,CHR_U,CHR_S,CHR_E,CHR_INTERR,127
			defb	CHR_S,CHR_O,CHR_U,CHR_N,CHR_D,CHR_INTERR,127
			defb	CHR_C,CHR_A,CHR_M,CHR_SPACE,CHR_1,CHR_INTERR,127
			defb	CHR_C,CHR_A,CHR_M,CHR_SPACE,CHR_2,CHR_INTERR,127

mpause_pause:		defb	129,160,131,30,229,CHR_P,CHR_A,CHR_U,CHR_S,CHR_E,CHR_SPACE
			defb	CHR_SPACE,CHR_SPACE,CHR_SPACE,CHR_SPACE,CHR_SPACE,CHR_SPACE
			defb	CHR_P,CHR_R,CHR_E,CHR_S,CHR_S,CHR_SPACE
			defb	CHR_QUOTES,CHR_A,CHR_QUOTES,CHR_SPACE,CHR_T,CHR_O
			defb	CHR_SPACE,CHR_A,CHR_B,CHR_O,CHR_R,CHR_T
			defb	127
mpause_abort:		defb	129,160,CHR_A,CHR_B,CHR_O,CHR_R,CHR_T,CHR_INTERR
			defb	CHR_N,CHR_COLON,CHR_B,CHR_A,CHR_C,CHR_K
			defb	CHR_Y,CHR_COLON,CHR_M,CHR_E,CHR_N,CHR_U
			defb	CHR_T,CHR_COLON,CHR_N,CHR_E,CHR_X,CHR_T
			defb	CHR_SPACE,CHR_T,CHR_R,CHR_A,CHR_C,CHR_K
			defb	127

mrecords_fixed:		defb	128,57,131,19,225,CHR_1,CHR_2,CHR_A,CHR_C,CHR_D,CHR_E,CHR_F,CHR_G,CHR_J,CHR_I,CHR_K,CHR_N,CHR_L,CHR_O,CHR_P,CHR_R,CHR_S,CHR_T,CHR_U

			defb	129,3,131,23,225,CHR_0_,CHR_1_,CHR_2_,CHR_3_,CHR_4_,CHR_5_,CHR_6_,CHR_7_,CHR_8_,CHR_9_,CHR_MINUS,CHR_POINT,CHR_SLASH
			defb	CHR_0,CHR_1,CHR_2,CHR_3,CHR_4,CHR_5,CHR_6,CHR_7,CHR_8,CHR_9
			defb	129,27,131,23,177,CHR_0_,CHR_1_,CHR_2_,CHR_3_,CHR_4_,CHR_5_,CHR_6_,CHR_7_,CHR_8_,CHR_9_,CHR_MINUS,CHR_POINT,CHR_SLASH
			defb	CHR_0,CHR_1,CHR_2,CHR_3,CHR_4,CHR_5,CHR_6,CHR_7,CHR_8,CHR_9
			defb	129,51,131,23,113,CHR_0_,CHR_1_,CHR_2_,CHR_3_,CHR_4_,CHR_5_,CHR_6_,CHR_7_,CHR_8_,CHR_9_,CHR_MINUS,CHR_POINT,CHR_SLASH
			defb	CHR_0,CHR_1,CHR_2,CHR_3,CHR_4,CHR_5,CHR_6,CHR_7,CHR_8,CHR_9
			defb	129,75,131,23,65,CHR_0_,CHR_1_,CHR_2_,CHR_3_,CHR_4_,CHR_5_,CHR_6_,CHR_7_,CHR_8_,CHR_9_,CHR_MINUS,CHR_POINT,CHR_SLASH
			defb	CHR_0,CHR_1,CHR_2,CHR_3,CHR_4,CHR_5,CHR_6,CHR_7,CHR_8,CHR_9
			defb	129,99,131,23,209,CHR_0_,CHR_1_,CHR_2_,CHR_3_,CHR_4_,CHR_5_,CHR_6_,CHR_7_,CHR_8_,CHR_9_,CHR_MINUS,CHR_POINT,CHR_SLASH
			defb	CHR_0,CHR_1,CHR_2,CHR_3,CHR_4,CHR_5,CHR_6,CHR_7,CHR_8,CHR_9
			defb	129,123,131+16*4+13,CHR_0_,CHR_1_,CHR_2_,CHR_3_,CHR_4_,CHR_5_,CHR_6_,CHR_7_,CHR_8_,CHR_9_,CHR_MINUS,CHR_POINT,CHR_SLASH
			defb	131+16*4+10,CHR_0,CHR_1,CHR_2,CHR_3,CHR_4,CHR_5,CHR_6,CHR_7,CHR_8,CHR_9
			defb	129,147,131+16*3+13,CHR_0_,CHR_1_,CHR_2_,CHR_3_,CHR_4_,CHR_5_,CHR_6_,CHR_7_,CHR_8_,CHR_9_,CHR_MINUS,CHR_POINT,CHR_SLASH
			defb	131+16*3+10,CHR_0,CHR_1,CHR_2,CHR_3,CHR_4,CHR_5,CHR_6,CHR_7,CHR_8,CHR_9
			defb	129,171,131+16*2+13,CHR_0_,CHR_1_,CHR_2_,CHR_3_,CHR_4_,CHR_5_,CHR_6_,CHR_7_,CHR_8_,CHR_9_,CHR_MINUS,CHR_POINT,CHR_SLASH
			defb	131+16*2+10,CHR_0,CHR_1,CHR_2,CHR_3,CHR_4,CHR_5,CHR_6,CHR_7,CHR_8,CHR_9
			defb	129,195,131+16*1+13,CHR_0_,CHR_1_,CHR_2_,CHR_3_,CHR_4_,CHR_5_,CHR_6_,CHR_7_,CHR_8_,CHR_9_,CHR_MINUS,CHR_POINT,CHR_SLASH
			defb	131+16*1+10,CHR_0,CHR_1,CHR_2,CHR_3,CHR_4,CHR_5,CHR_6,CHR_7,CHR_8,CHR_9
			defb	130,33,131,8,225,CHR_1,CHR_2,CHR_3,CHR_4,CHR_5,CHR_6,CHR_7,CHR_8
			defb	130,128,131,128,33
			defb	127

mpers_init:		defb	128,57,131,22,225,CHR_1,CHR_8,CHR_A,CHR_C,CHR_D,CHR_E,CHR_H,CHR_I,CHR_K,CHR_L,CHR_M,CHR_N,CHR_O,CHR_P,CHR_R,CHR_S,CHR_T,CHR_Z,CHR_COLON,CHR_MINUS,CHR_RETURN,CHR_BACKSPACE
			defb	129,1,131,8,113
			defb	129,9,131,28,225,129,12,CHR_0,CHR_1,CHR_5,CHR_6,CHR_A,CHR_B,CHR_C,CHR_D,CHR_E,CHR_F,CHR_G,CHR_H,CHR_I,CHR_K,CHR_L,CHR_N,CHR_O,CHR_P,CHR_R,CHR_S,CHR_T,CHR_COLON,CHR_MINUS,CHR_BACKSPACE,CHR_RETURN
			defb	130,33,131,20,225,CHR_1,CHR_2,CHR_3,CHR_4,CHR_5,CHR_6,CHR_7,CHR_8,CHR_A,CHR_E,CHR_F,CHR_L,CHR_O,CHR_P,CHR_R,CHR_S,CHR_T,CHR_EXCL
			defb	130,128,131,128,33
			defb	127
end_podium:		defb	128,1,131,28,241
			defb	128,29,131,28,113
			defb	130,1,131,19,225,CHR_A,CHR_C,CHR_E,CHR_F,CHR_G,CHR_H,CHR_I,CHR_L,CHR_M,CHR_N,CHR_O,CHR_P,CHR_R,CHR_S,CHR_T,CHR_V,CHR_X,CHR_Y,CHR_EXCL
			defb	127
mneed_ram:		defb	129,107,131,10,224,CHR_I,CHR_SPACE,CHR_N,CHR_E,CHR_E,CHR_D,CHR_SPACE,CHR_R,CHR_A,CHR_M
			defb	127
